% 
% % %% make ising samples
% data=zeros(21000,1600);
% for jct=1:3
%     for ict=1:7000
%         data(7000*(jct-1)+ict,:)=reshape(ising2(40,round(10+(0.2+0.240687*(jct-1))*100),(0.2+0.240687*(jct-1)),1),1600,1);
%     end
% end
% labels=ones(21000,1);
% labels(7001:14000)=2;
% labels(14001:21000)=3;
% testdata=zeros(21000,1600);
% for jct=1:3
%     for ict=1:7000
%         testdata(7000*(jct-1)+ict,:)=reshape(ising2(40,round(10+(0.2+0.240687*(jct-1))*100),(0.2+0.240687*(jct-1)),1),1600,1);
%     end
% end
% testlabels=ones(21000,1);
% testlabels(7001:14000)=2;
% testlabels(14001:21000)=3;
% data=(data+1)/2;
% testdata=(testdata+1)
%%

for ict=1:21000
 data(ict,:)=reshape(ising2(40,100,0.43,1),1600,1);
end
 
for ict=1:7000
    testdata(ict,:)=reshape(ising2(40,100,0.43,1),1600,1);
end
 save data;
 save testdata;
% %%
% data=zeros(21000,1600);
% for ict=1:21000
%     data(ict,:)=reshape(ising2(40,round(10+0.440687*100),1/(1.22/0.440687),1),1600,1);
% end
% data=(data+1)/2;
% 
% labels=ones(21000,1);
% labels(7001:14000)=2;
% labels(14001:21000)=3;

%% Train a DBN
hid=[800 1];
labels=ones(1,size(data,1));
op.verbose=true;
models=dbnFit(data,hid,labels,op,op);
%yhat2=dbnPredict(models,testdata);
%print error
%fprintf('Classification error using DBN with 100-100 hiddens is %f\n', ...
 %   sum(yhat2~=testlabels)/length(yhat2));


% 
% %visualize weights
% figure(4)
% subplot(1,2,1)
% visualize(models{1}.W);
% title('learned weights on DBN layer 1');
% subplot(1,2,2)
% visualize(models{2}.W);
% title('learned weights on DBN layer 2');
% 
% %visualize the mislabeled cases. Note the transpose. Visualize assumes DxN
% %as is the case for weights
% figure(5)
% visualize(data(yhat2~=testlabels,:)');

% title('classification mistakes for DBN with 100-100 hiddens');
%%
model=rbmBB2(data, 1200, 4E-4,0, model)
save model;
%% find filters for each level
weights=cell(length(hid),1);
weights{1}=models{1}.W;

for hct=2:length(hid)
    weights{hct}=zeros(1600,hid(hct));
    for ict=1:hid(hct)
        weights{hct}(:,ict)=weights{hct-1}*models{hct}.W(:,ict);
    end
    
end
%% plot filters for a layer
X=weights{3};
%X=models{1}.W;
[D,N]= size(X);
s=sqrt(D);
num=ceil(sqrt(N));
a=zeros(num*s+num+1,num*s+num+1)-1;
x=0;
y=0;
for i=1:N
    a(x*s+1+x:x*s+s+x,y*s+1+y:y*s+s+y)=reshape(X(:,i),s,s)';
    x=x+1;
    if(x>=num)
        x=0;
        y=y+1;
    end
end
figure;
%imshow(a,[-1,1]);
% 
imagesc(a);
%%
N=1600;
Nh=1200;
vee=zeros(N,1);
hv=zeros(N,1);
Jv=zeros(N,N);
Jh=zeros(Nh,Nh);
e0v=EnergyRBM(vee,model.W,model.c',model.b');
veeh=zeros(Nh,1);
e0h=EnergyRBM(veeh,model.W',model.b',model.c');



for ict=1:N
    vee=zeros(N,1);
    vee(ict)=1;
    hv(ict)= -EnergyRBM(vee,model.W,model.c',model.b')+e0v;
   % h(ict)= EnergyRBM(vee,model.W,model.c',model.b')-e0;

end
%

for ict=1:Nh
    veeh=zeros(Nh,1);
    veeh(ict)=1;
    hh(ict)= -EnergyRBM(veeh,model.W',model.b',model.c')+e0h;
   % h(ict)= EnergyRBM(vee,model.W,model.c',model.b')-e0;

end
figure
binranges=[-5:.1:0];bincounts=histc(h,binranges);bar(binranges,bincounts)
figure
binranges=[-5:.1:0];bincounts=histc(hh,binranges);bar(binranges,bincounts)
%%
Jv=zeros(N,N);
for ict=1:N
    ict
    for jct=1:N
        vee=zeros(N,1);
        vee(ict)=1;
        vee(jct)=1;
        Jv(ict,jct)=-EnergyRBM(vee,model.W,model.c',model.b')-hv(ict)-hv(jct)+e0v;
        %J(ict,jct)=EnergyRBM(vee,model.W,model.c',model.b')-h(ict)-h(jct)-e0;

        if ict==jct
            Jv(ict,jct)=0;
        end
    end
end
%%
Jh=zeros(Nh,Nh);

for ict=1:Nh
    ict
    for jct=1:Nh
        veeh=zeros(Nh,1);
        veeh(ict)=1;
        veeh(jct)=1;
        Jh(ict,jct)=-EnergyRBM(veeh,model.W',model.b',model.c')-hh(ict)-hh(jct)+e0h;
        %J(ict,jct)=EnergyRBM(vee,model.W,model.c',model.b')-h(ict)-h(jct)-e0;

        if ict==jct
            Jh(ict,jct)=0;
        end
    end
end

